function [M1, M2]=GenGameMatrixWithPunishment2(n1,n2,lc1,lc2,tc1,tc2)
% M1 is the cost matrix of network 1
% M2 is the cost matrix of network 2
% n1 is the gateway number of network 1
% n2 is the gateway number of network 2
% lc1 is the gateway cost of network 1
% lc2 is the gateway cost of network 2
% tc1 is the route cost of network 1
% tc2 is the route cost of network 2
M1=zeros(n1*n2, n1*n2);
M2=zeros(n1*n2, n1*n2);
p1=1.4;
p2=1.6;
for i=1:n1*n2
    for j=1:n1*n2
        g1=ceil(i/n2);
        g2=ceil(j/n1);
        l1=i-(g1-1)*n2;
        l2=j-(g2-1)*n1;
        locost1=lc1(l2);
        locost2=lc2(l1);
        trcost1=tc1(i);
        trcost2=tc2(j);
        if g1==l2
            trcost1=trcost1*p1;
            trcost2=trcost2*p2;
        end
        if l1==g2
            trcost1=trcost1*p2;
            trcost2=trcost2*p1;
        end
        
        M1(i,j)=locost1+trcost1;
        M2(i,j)=locost2+trcost2;
    end
end
