function [s1 s2 c1 c2] = SolveMixedStrategies(M1, M2, s1, s2)
[n1 n2]=size(M1);
if n2>=n1
    r=zeros(1,n1);
    r(n1)=1;
    C=nchoosek(1:n2,n1);
    k=size(C,1);
    tmp=zeros(1,k);
    for i=1:k
        CB=M2(:,C(i,:));
        KB=MatrixTransform(CB);
        detKB=det(KB);
        valid = 1;
        if detKB == 0
            tmp(i)=inf;
            continue;
        end
        for j=1:n1
            MjN=KB;
            MjN(:,n1)=[];
            MjN(j,:)=[];
            sig=(-1)^(mod(n1+j,2));
            t=sig*det(MjN)/detKB;
            if t <=0 || t>=1
                valid = 0;
                break;
            end
        end
        if valid == 1
            tmp(i)=det(CB)/detKB;
        else
            tmp(i)=inf;
        end
    end
    c2=0;
    while c2<=0
        [c2 j]=min(tmp);
        if c2<=0
            tmp(j)=inf;
        end
    end
    CB=M2(:,C(j,:));
    KB=MatrixTransform(CB);
    p1=KB'\r';
    s2=s2(C(j,:),:);
    a=M1(:,C(j,:));
    KA=MatrixTransform(a')';
    p2=KA\r';
    c1=a(1,:)*p2;
    s1(:,2)=p1;
    s2(:,2)=p2;
else
    [s2 s1 c2 c1] = SolveMixedStrategies(M2', M1', s2, s1);
end

end

