clear;clc;
file='result.dat';
fid = fopen(file,'r');
result = fscanf(fid, '%f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f', [24,inf]);
fclose(fid);
cost=result(1:6,:);
div=result(7:12,:);
stab=result(13:18,:);
dlc=result(19:24,:);
label = [ 'AS 12182';
          'AS 4685 ';
          'AS 12182';
          'AS 4685 ';
          'AS 12182';
          'AS 4685 '];
liney=-1:5:1000;
linex1=2.5*ones(size(liney));
linex2=4.5*ones(size(liney));
scrsz = get(0,'ScreenSize');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure('Position',[1 scrsz(4)/2 scrsz(3)/2 0.2*scrsz(3)]);
boxplot(cost');
% because each bin is .5 data units wide.
set(gca,'XLim',[.5 6.5]);% This automatically sets the
                         % XLimMode to manual.
set(gca,'XTick',[1:6])  % This automatically sets 
                         % the XTickMode to manual.

set(gca,'XTickLabel',label)
ylabel('routing cost');

hold on
plot(linex1,liney,':',linex2,liney,':');
plot(1:6,median(cost,2),'*');
hold off
y=22;
set(gca,'YLim',[-0.5 y]);
text(1.3, 24/25*y, 'GE2E-TE');
text(3.3, 24/25*y, 'LISP');
text(5.3, 24/25*y, 'MP-BGP');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%figure(2)
figure('Position',[1 scrsz(4)/2 scrsz(3)/2 0.2*scrsz(3)]);
boxplot(div');
set(gca,'XLim',[.5 6.5]);% This automatically sets the
                         % XLimMode to manual.
set(gca,'XTick',[1:6])  % This automatically sets 
                         % the XTickMode to manual.

set(gca,'XTickLabel',label)
ylabel('path diversity of the routing solution');
hold on
plot(linex1,liney,':',linex2,liney,':');
plot(1:6,median(div,2),'*');
hold off
y=800;
set(gca,'YLim',[-0.5 y]);
text(1.3, 24/25*y, 'GE2E-TE');
text(3.3, 24/25*y, 'LISP');
text(5.3, 24/25*y, 'MP-BGP');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure('Position',[1 scrsz(4)/2 scrsz(3)/2 0.2*scrsz(3)]);
%figure(3)
boxplot(stab');
set(gca,'XLim',[.5 6.5]);% This automatically sets the
                         % XLimMode to manual.
set(gca,'XTick',[1:6])  % This automatically sets 
                         % the XTickMode to manual.

set(gca,'XTickLabel',label);
ylabel('path stability of the routing solution');
hold on
plot(linex1,liney,':',linex2,liney,':');
plot(1:6,median(stab,2),'*');
hold off
y=1.1;
set(gca,'YLim',[-0.1 y]);
text(1.3, 24/25*y, 'GE2E-TE');
text(3.3, 24/25*y, 'LISP');
text(5.3, 24/25*y, 'MP-BGP');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure('Position',[1 scrsz(4)/2 scrsz(3)/2 0.2*scrsz(3)]);
sumcost=zeros(3,size(cost,2));
for i=1:3
    sumcost(i,:)=cost((i-1)*2+1,:)+cost((i-1)*2+1,:);
end
boxplot(sumcost');
set(gca,'XLim',[.5 3.5]);% This automatically sets the
                         % XLimMode to manual.
set(gca,'XTick',[1:3])  % This automatically sets 
                         % the XTickMode to manual.
label=['E2E-TE';'LISP  ';'MP-BGP'];
set(gca,'XTickLabel',label);
ylabel('The sum of routing cost');
hold on
%plot(linex1,liney,':',linex2,liney,':');
%plot(1:3,median(sumcost,2),'*');
%hold off

%set(gca,'YLim',[-0.1 650]);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure('Position',[1 scrsz(4)/2 scrsz(3)/2 0.2*scrsz(3)]);
sumdlc=zeros(3,size(dlc,2));
for i=1:3
    sumdlc(i,:)=dlc((i-1)*2+1,:)+dlc((i-1)*2+1,:);
end
boxplot(sumdlc');
% because each bin is .5 data units wide.
set(gca,'XLim',[.5 3.5]);% This automatically sets the
                         % XLimMode to manual.
set(gca,'XTick',[1:3])  % This automatically sets 
                         % the XTickMode to manual.

set(gca,'XTickLabel',label)
ylabel('destination locator cost');

hold on
%plot(linex1,liney,':',linex2,liney,':');
plot(1:3,median(sumdlc,2),'*');
hold off
y=22;
%set(gca,'YLim',[-0.5 y]);
text(1.3, 24/25*y, 'E2E-TE');
text(3.3, 24/25*y, 'LISP');
text(5.3, 24/25*y, 'MP-BGP');